/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2012 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __chrono
#define __chrono

#include <ctime>
#include <time.h>

struct chrono {

  double secs;
  double ticks;

  double delta_secs;
  int delta_ticks;

  chrono ();
  chrono& operator++ ();

};

struct nano_chrono {
  timespec start, now, delta;
  double secs;
  void reset ();
  void tick ();
  void find_elapsed ();
};

#endif
